'use strict';


// Declare app level module which depends on filters, and services
angular.module('myApp', [
  'ngRoute',
  'geolocation',
  'ngGPlaces',
  'myApp.filters',
  'myApp.services',
  'myApp.directives',
  'myApp.controllers'
]).
config(['$routeProvider', function($routeProvider) {
    $routeProvider.when('/', {templateUrl: 'views/home.html', controller: 'HomeController',activetab: 'home'});
    $routeProvider.when('/prayers', {templateUrl: 'views/prayertimes.html', controller: 'PrayerTimes',activetab: 'prayers'});
    $routeProvider.when('/mosques', {templateUrl: 'views/nearestmosques.html', controller: 'NearestMosque',activetab: 'mosques'});

    $routeProvider.when('/services', {templateUrl: 'views/azanservice.html', controller: 'AzanService',activetab: 'services'});

    $routeProvider.otherwise({redirectTo: '/'});
}])
.run(['geolocation','$rootScope','$location',function(geolocation,$rootScope,$location){
    return geolocation.getLocation().then(function(data){
        $rootScope.latitude  = data.coords.latitude;
        $rootScope.longitude = data.coords.longitude;
        var path = function() { return $location.path();};
        $rootScope.$watch(path, function(newVal, oldVal){
            $rootScope.activetab = newVal;
        });
    });
}]);

//tool bar
//$('.tab-bar a').on('click',function(e){
//    $(this).addClass('active');
//    $(this).parent().siblings().find('a').removeClass('active');
//});
