'use strict';

/* Directives */


angular.module('myApp.directives', []).
  directive('appVersion', ['version', function(version) {
    return function(scope, elm, attrs) {
      elm.text(version);
    };
  }]).directive('prayerCountDown',[function(){
        return {
            restrict: 'AE',
            templateUrl: 'directives/prayercountdown.html',
            replace    :true,
            link: function(scope,elem,attrs){
                //convert duration to hours
                var durationInMin;
                var duration;
                var display;
                scope.$watch('timeRemaining', function(newVal,oldVal) {
                     if(newVal != oldVal) {
                         durationInMin = parseInt(scope.timeRemaining);
                         display  = $('#count-down');
                         //console.log(durationInMin);
                         getTimeFormat(durationInMin,display);
                         startTimer(durationInMin, display);
                     }
                }, true);
                function startTimer(durationInMin, display) {
                    setInterval(function () {
                        //getTimeFormat(durationInMin,display,true);
                        duration        = durationInMin/60;
                        var hours, minutes,roundedMin;
                        if(durationInMin <= 0){
                            durationInMin = durationInMin;
                            hours   = "00";
                            minutes = "00";
                        }else{
                            --durationInMin;
                            hours   = parseInt(duration.toString().split(".")[0]);
                            if(duration.toString().split(".").length > 1){
                                var minString   = "0."+(duration.toString().split(".")[1]);
                                minutes = Math.round(minString * 60);

                            }else{
                                minutes = 0;
                            }

                            minutes = minutes < 10 ? "0" + minutes : minutes;
                            hours = hours < 10 ? "0" + hours : hours;
                        }

                        //display.html('<div class="hours-holder">'+hours+'</div>'
                        //+ '<div class="separator-holder">:</div>'
                        //+ '<div class="minutes-holder">'+minutes+'</div>');
                        display.html(hours + ":" + minutes);
                    },60*1000);
                }

                function getTimeFormat(durationInMin,display,timeOut){
                    var duration        = durationInMin/60;
                    var hours, minutes,roundedMin;
                    if(durationInMin <= 0){
                        durationInMin = durationInMin;
                        hours   = "00";
                        minutes = "00";
                    }else{
                        hours   = parseInt(duration.toString().split(".")[0]);
                        if(duration.toString().split(".").length > 1){
                            var minString   = "0."+(duration.toString().split(".")[1]);
                            minutes = Math.round(minString * 60);

                        }else{
                            minutes = 0;
                        }

                        minutes = minutes < 10 ? "0" + minutes : minutes;
                        hours = hours < 10 ? "0" + hours : hours;
                    }

                    display.html(hours + ":" + minutes);


                    //display.html('<div class="hours-holder">'+hours+'</div>'
                    //           + '<div class="separator-holder">:</div>'
                    //           + '<div class="minutes-holder">'+minutes+'</div>');
                }

                function displayCountDown(display,hours,minutes){
                    var hrsDiv       = $('<div class="hours-holder">'+hours+'</div>');
                    var minDiv       = $('<div class="minutes-holder">'+minutes+'</div>');
                    var separatorDiv = $('<div class="separator-holder"></div>');

                }


            }
        }
    }]).


    directive('nearestMosque',function(){
        return{
            restrict:'AE',
            template:'<div id="map"></div>',
            replace:true
        }
    }).

    directive('prayerTimes',function(){
        return{
            restrict:'AE',
            templateUrl:'directives/prayertimes.html',
            replace:true,
            link: function(scope,elem,attrs){
                scope.$watch('prayerTimes', function(newVal,oldVal) {
                    if(newVal != oldVal) {
                        scope.prayerTimes =  newVal;
                    }
                }, true);
                scope.today = new Date();
            }
        }
    }).
    directive('azanPlayerTable',function(){

        return{
            restrict:'AE',
            templateUrl:'directives/azanplayertable.html',
            replace:true,
            link: function(scope,elem,attrs){
                $(elem).on('click','.np-play',function(e){
                    console.log('clicked');
                    var songName = e.target.getAttribute('data-src');
                    var audioPlayer = document.querySelector('#player');
                    var self = $(this);


                    if (audioPlayer) {

                        if (songName===audioPlayer.getAttribute('src')) {
                            if (audioPlayer.paused) {
                                audioPlayer.play();
                                e.target.id = 'paused';
                            } else {
                                audioPlayer.pause();
                                e.target.id = 'play';


                            }
                        } else {
                            //if the clicked song name isnt the one currently playing
                            audioPlayer.src = songName;
                            audioPlayer.play();
                            e.target.id = 'paused';
                            if (document.querySelector('#playing')) {
                                document.querySelector('#playing').id='';
                            } else {
                                document.querySelector('#paused').id='';
                            }
                            e.target.id = 'playing';
                        }



                    } else {
                        var audioPlayer = document.createElement('audio');
                        audioPlayer.id = 'player';
                        e.target.id = 'playing';
                        audioPlayer.src = songName;
                        $(elem).append(audioPlayer);
                        audioPlayer.play();


                        audioPlayer.addEventListener('ended', function() {
                            audioPlayer.parentNode.removeChild(audioPlayer);
                            e.target.id='';
                        }, false);
                    }


                });
            }
        }
    }).
    directive('audioDropDown',function(){

        return{
            restrict:'AE',
            templateUrl:'directives/azanaudioplayer.html',
            replace:true,
            link: function(scope,elem,attrs){
                $(elem).on('click','.np-play',function(e){
                    console.log('clicked');
                    var songName = e.target.getAttribute('data-src');
                    var audioPlayer = document.querySelector('#player');
                    var self = $(this);


                    if (audioPlayer) {

                        if (songName===audioPlayer.getAttribute('src')) {
                            if (audioPlayer.paused) {
                                audioPlayer.play();
                                e.target.id = 'paused';
                            } else {
                                audioPlayer.pause();
                                e.target.id = 'play';


                            }
                        } else {
                            //if the clicked song name isnt the one currently playing
                            audioPlayer.src = songName;
                            audioPlayer.play();
                            e.target.id = 'paused';
                            if (document.querySelector('#playing')) {
                                document.querySelector('#playing').id='';
                            } else {
                                document.querySelector('#paused').id='';
                            }
                            e.target.id = 'playing';
                        }



                    } else {
                        var audioPlayer = document.createElement('audio');
                        audioPlayer.id = 'player';
                        e.target.id = 'playing';
                        audioPlayer.src = songName;
                        $(elem).append(audioPlayer);
                        audioPlayer.play();


                        audioPlayer.addEventListener('ended', function() {
                            audioPlayer.parentNode.removeChild(audioPlayer);
                            e.target.id='';
                        }, false);
                    }


                });
            }
        }
    });
